import {
  hotUpdateSetupComponent,
  loadSetupComponent,
  transformSetupComponent
} from "./chunk-6MPAENN3.mjs";
import {
  SETUP_COMPONENT_ID_REGEX
} from "./chunk-ZUROAGHW.mjs";

// src/index.ts
import { createUnplugin } from "unplugin";
import { createFilter } from "@rollup/pluginutils";
function resolveOption(options) {
  return {
    include: [/\.[cm]?[jt]sx?$/],
    root: process.cwd(),
    ...options
  };
}
var name = "unplugin-vue-setup-component";
var src_default = createUnplugin((userOptions = {}) => {
  const options = resolveOption(userOptions);
  const filter = createFilter(options.include, options.exclude);
  const setupComponentContext = {};
  return {
    name,
    resolveId(id) {
      if (SETUP_COMPONENT_ID_REGEX.test(id))
        return id;
    },
    loadInclude(id) {
      return SETUP_COMPONENT_ID_REGEX.test(id);
    },
    load(id) {
      return loadSetupComponent(id, setupComponentContext, options.root);
    },
    transformInclude(id) {
      return filter(id);
    },
    transform(code, id) {
      try {
        return transformSetupComponent(code, id, setupComponentContext);
      } catch (err) {
        this.error(`${name} ${err}`);
      }
    },
    vite: {
      configResolved(config) {
        options.root = config.root;
      },
      handleHotUpdate: (ctx) => {
        if (filter(ctx.file)) {
          return hotUpdateSetupComponent(ctx, setupComponentContext);
        }
      }
    }
  };
});

export {
  src_default
};
