import { HmrContext, ModuleNode } from 'vite';
import { Node } from '@babel/types';
export { SETUP_COMPONENT_ID_REGEX, SETUP_COMPONENT_ID_SUFFIX, SETUP_COMPONENT_SUB_MODULE, SETUP_COMPONENT_TYPE } from './constants.js';

interface NodeContext {
    code: string;
    body: string;
    node: Node;
}
declare type SetupComponentContext = Record<string, NodeContext[]>;
declare const scanSetupComponent: (code: string, id: string) => NodeContext[];
declare const transformSetupComponent: (code: string, id: string, ctx: SetupComponentContext) => {
    code: string;
    map: any;
} | undefined;
declare const loadSetupComponent: (virtualId: string, ctx: SetupComponentContext, root: string) => string | undefined;
declare const hotUpdateSetupComponent: ({ file, modules, read }: HmrContext, ctx: SetupComponentContext) => Promise<ModuleNode[] | undefined>;

export { SetupComponentContext, hotUpdateSetupComponent, loadSetupComponent, scanSetupComponent, transformSetupComponent };
